Index: trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp
===================================================================
--- trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 253)
+++ trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 273)
@@ -2483,5 +2707,5 @@
         else if ( r_read_to_ixr_cmd_req  )     r_ixr_cmd_fsm = IXR_CMD_READ_NLINE;
         break;
-        //////////////////////// 
+        ////////////////////////
         case IXR_CMD_WRITE_IDLE:
         if      ( r_sc_to_ixr_cmd_req  )       r_ixr_cmd_fsm = IXR_CMD_SC_NLINE;
@@ -2490,5 +2714,5 @@
         else if ( r_write_to_ixr_cmd_req )     r_ixr_cmd_fsm = IXR_CMD_WRITE_NLINE;
         break;
-        //////////////////////// 
+        ////////////////////////
         case IXR_CMD_SC_IDLE:
         if      ( r_xram_rsp_to_ixr_cmd_req  ) r_ixr_cmd_fsm = IXR_CMD_XRAM_DATA;
@@ -2497,5 +2721,5 @@
         else if ( r_sc_to_ixr_cmd_req  )       r_ixr_cmd_fsm = IXR_CMD_SC_NLINE;
         break;
-        //////////////////////// 
+        ////////////////////////
         case IXR_CMD_XRAM_IDLE:
         if      ( r_read_to_ixr_cmd_req  )     r_ixr_cmd_fsm = IXR_CMD_READ_NLINE;
@@ -2506,7 +2730,7 @@
         /////////////////////////       // send a get request to XRAM
         case IXR_CMD_READ_NLINE:
-        if ( p_vci_ixr.cmdack ) 
-        {
-            r_ixr_cmd_fsm = IXR_CMD_READ_IDLE;		
+        if ( p_vci_ixr.cmdack )
+        {
+            r_ixr_cmd_fsm = IXR_CMD_READ_IDLE;
             r_read_to_ixr_cmd_req = false;
 
@@ -2520,16 +2744,16 @@
         break;
         //////////////////////////
-        case IXR_CMD_WRITE_NLINE:	    // send a put or get command to XRAM
-        if ( p_vci_ixr.cmdack ) 
+        case IXR_CMD_WRITE_NLINE:     // send a put or get command to XRAM
+        if ( p_vci_ixr.cmdack )
         {
             if( r_write_to_ixr_cmd_write.read())
             {
-                if ( r_ixr_cmd_cpt.read() == (m_words - 1) ) 
+                if ( r_ixr_cmd_cpt.read() == (m_words - 1) )
                 {
                     r_ixr_cmd_cpt = 0;
                     r_ixr_cmd_fsm = IXR_CMD_WRITE_IDLE;
                     r_write_to_ixr_cmd_req = false;
-                } 
-                else 
+                }
+                else
                 {
                     r_ixr_cmd_cpt = r_ixr_cmd_cpt + 1;
@@ -2542,8 +2766,8 @@
 }
 #endif
-            } 
-            else 
-            {
-                r_ixr_cmd_fsm = IXR_CMD_WRITE_IDLE;		
+            }
+            else
+            {
+                r_ixr_cmd_fsm = IXR_CMD_WRITE_IDLE;
                 r_write_to_ixr_cmd_req = false;
 
@@ -2559,15 +2783,15 @@
         //////////////////////
         case IXR_CMD_SC_NLINE:      // send a put or get command to XRAM
-        if ( p_vci_ixr.cmdack ) 
+        if ( p_vci_ixr.cmdack )
         {
             if( r_sc_to_ixr_cmd_write.read())
             {
-                if ( r_ixr_cmd_cpt.read() == (m_words - 1) ) 
+                if ( r_ixr_cmd_cpt.read() == (m_words - 1) )
                 {
                     r_ixr_cmd_cpt = 0;
                     r_ixr_cmd_fsm = IXR_CMD_SC_IDLE;
                     r_sc_to_ixr_cmd_req = false;
-                } 
-                else 
+                }
+                else
                 {
                     r_ixr_cmd_cpt = r_ixr_cmd_cpt + 1;
@@ -2580,8 +2804,8 @@
 }
 #endif
-            } 
-            else 
-            {
-                r_ixr_cmd_fsm = IXR_CMD_SC_IDLE;		
+            }
+            else
+            {
+                r_ixr_cmd_fsm = IXR_CMD_SC_IDLE;
                 r_sc_to_ixr_cmd_req = false;
 
@@ -2597,13 +2821,13 @@
         ////////////////////////
         case IXR_CMD_XRAM_DATA:     // send a put command to XRAM
-        if ( p_vci_ixr.cmdack ) 
-        {
-            if ( r_ixr_cmd_cpt.read() == (m_words - 1) ) 
+        if ( p_vci_ixr.cmdack )
+        {
+            if ( r_ixr_cmd_cpt.read() == (m_words - 1) )
             {
                 r_ixr_cmd_cpt = 0;
                 r_ixr_cmd_fsm = IXR_CMD_XRAM_IDLE;
                 r_xram_rsp_to_ixr_cmd_req = false;
-            } 
-            else 
+            }
+            else
             {
                 r_ixr_cmd_cpt = r_ixr_cmd_cpt + 1;
@@ -2631,5 +2855,5 @@
     // The FSM takes the lock protecting the TRT, and the corresponding
     // entry is erased.
-    //	
+    //
     // - A response to a get request is a multi-cell VCI packet.
     // The Transaction Tab index is contained in the RTRDID field.
@@ -2640,10 +2864,10 @@
     ///////////////////////////////////////////////////////////////////////////////
 
-    switch ( r_ixr_rsp_fsm.read() ) 
+    switch ( r_ixr_rsp_fsm.read() )
     {
         //////////////////
-        case IXR_RSP_IDLE:	// test if it's a get or a put transaction
-        {
-            if ( p_vci_ixr.rspval.read() ) 
+        case IXR_RSP_IDLE:  // test if it's a get or a put transaction
+        {
+            if ( p_vci_ixr.rspval.read() )
             {
                 r_ixr_rsp_cpt   = 0;
@@ -2654,72 +2878,72 @@
 
 #if DEBUG_MEMC_IXR_RSP
-if( m_debug_ixr_rsp_fsm ) 
+if( m_debug_ixr_rsp_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".IXR_RSP_IDLE> Response from XRAM to a put transaction" << std::endl; 
+    std::cout << "  <MEMC " << name() << ".IXR_RSP_IDLE> Response from XRAM to a put transaction" << std::endl;
 }
 #endif
                 }
-                else 							       // get transaction
+                else                     // get transaction
                 {
-  		    r_ixr_rsp_fsm = IXR_RSP_TRT_READ;
-
-#if DEBUG_MEMC_IXR_RSP
-if( m_debug_ixr_rsp_fsm ) 
-{
-    std::cout << "  <MEMC " << name() << ".IXR_RSP_IDLE> Response from XRAM to a get transaction" << std::endl; 
-}
-#endif
-                }
-            }
-            break;  
-        }
-        ////////////////////////
-        case IXR_RSP_ACK:        // Aknowledge the VCI response
-        {
-            if(p_vci_ixr.rspval.read()) r_ixr_rsp_fsm = IXR_RSP_TRT_ERASE;
-
-#if DEBUG_MEMC_IXR_RSP
-if( m_debug_ixr_rsp_fsm ) 
-{
-    std::cout << "  <MEMC " << name() << ".IXR_RSP_ACK>" << std::endl; 
-}
-#endif
-            break;
-        }
-        ////////////////////////
-        case IXR_RSP_TRT_ERASE: 	// erase the entry in the TRT
-        {
-            if ( r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP ) 
-            {
-                m_transaction_tab.erase(r_ixr_rsp_trt_index.read());
-                r_ixr_rsp_fsm = IXR_RSP_IDLE;
+          r_ixr_rsp_fsm = IXR_RSP_TRT_READ;
 
 #if DEBUG_MEMC_IXR_RSP
 if( m_debug_ixr_rsp_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".IXR_RSP_TRT_ERASE> Erase TRT entry " 
-              << r_ixr_rsp_trt_index.read() << std::endl; 
+    std::cout << "  <MEMC " << name() << ".IXR_RSP_IDLE> Response from XRAM to a get transaction" << std::endl;
 }
 #endif
+                }
             }
             break;
         }
+        ////////////////////////
+        case IXR_RSP_ACK:        // Aknowledge the VCI response
+        {
+            if(p_vci_ixr.rspval.read()) r_ixr_rsp_fsm = IXR_RSP_TRT_ERASE;
+
+#if DEBUG_MEMC_IXR_RSP
+if( m_debug_ixr_rsp_fsm )
+{
+    std::cout << "  <MEMC " << name() << ".IXR_RSP_ACK>" << std::endl;
+}
+#endif
+            break;
+        }
+        ////////////////////////
+        case IXR_RSP_TRT_ERASE:   // erase the entry in the TRT
+        {
+            if ( r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP )
+            {
+                m_transaction_tab.erase(r_ixr_rsp_trt_index.read());
+                r_ixr_rsp_fsm = IXR_RSP_IDLE;
+
+#if DEBUG_MEMC_IXR_RSP
+if( m_debug_ixr_rsp_fsm )
+{
+    std::cout << "  <MEMC " << name() << ".IXR_RSP_TRT_ERASE> Erase TRT entry "
+              << r_ixr_rsp_trt_index.read() << std::endl;
+}
+#endif
+            }
+            break;
+        }
         ///////////////////////
-        case IXR_RSP_TRT_READ:		// write data in the TRT
-        {
-            if ( (r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) &&  p_vci_ixr.rspval ) 
+        case IXR_RSP_TRT_READ:    // write data in the TRT
+        {
+            if ( (r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) &&  p_vci_ixr.rspval )
             {
                 size_t index    = r_ixr_rsp_trt_index.read();
-                bool   eop  	= p_vci_ixr.reop.read();
-                data_t data 	= p_vci_ixr.rdata.read();
+                bool   eop    = p_vci_ixr.reop.read();
+                data_t data   = p_vci_ixr.rdata.read();
                 bool   error    = ((p_vci_ixr.rerror.read() & 0x1) == 1);
-                assert(((eop == (r_ixr_rsp_cpt.read() == (m_words-1))) || p_vci_ixr.rerror.read()) 
+                assert(((eop == (r_ixr_rsp_cpt.read() == (m_words-1))) || p_vci_ixr.rerror.read())
                     and "Error in VCI_MEM_CACHE : invalid length for a response from XRAM");
-                m_transaction_tab.write_rsp(index, 
-                                            r_ixr_rsp_cpt.read(), 
-                                            data, 
+                m_transaction_tab.write_rsp(index,
+                                            r_ixr_rsp_cpt.read(),
+                                            data,
                                             error);
                 r_ixr_rsp_cpt = r_ixr_rsp_cpt.read() + 1;
-                if ( eop ) 
+                if ( eop )
                 {
                     r_ixr_rsp_to_xram_rsp_rok[r_ixr_rsp_trt_index.read()]=true;
@@ -2751,6 +2975,6 @@
     // a round-robin priority...
     //
-    // When a response is available, the corresponding TRT entry 
-    // must be copied in a local buffer to be written in the cache. 
+    // When a response is available, the corresponding TRT entry
+    // must be copied in a local buffer to be written in the cache.
     // The FSM takes the lock protecting the TRT, and the lock protecting the DIR.
     // It selects a cache slot and writes the line in the cache.
@@ -2759,13 +2983,13 @@
     // If there is no empty slot, a victim line is evicted, and
     // invalidate requests are sent to the L1 caches containing copies.
-    // If this line is dirty, the XRAM_RSP FSM send a request to the IXR_CMD 
+    // If this line is dirty, the XRAM_RSP FSM send a request to the IXR_CMD
     // FSM to save the victim line to the XRAM, and register the write transaction
     // in the TRT (using the entry previously used by the read transaction).
     ///////////////////////////////////////////////////////////////////////////////
 
-    switch ( r_xram_rsp_fsm.read() ) 
+    switch ( r_xram_rsp_fsm.read() )
     {
         ///////////////////
-        case XRAM_RSP_IDLE:	// scan the XRAM responses to get the TRT index (round robin)
+        case XRAM_RSP_IDLE: // scan the XRAM responses to get the TRT index (round robin)
         {
             size_t ptr   = r_xram_rsp_trt_index.read();
@@ -2776,11 +3000,11 @@
                 if ( r_ixr_rsp_to_xram_rsp_rok[index] )
                 {
-                    r_xram_rsp_trt_index		= index;
-                    r_ixr_rsp_to_xram_rsp_rok[index]	= false;
-                    r_xram_rsp_fsm           		= XRAM_RSP_DIR_LOCK;
+                    r_xram_rsp_trt_index             = index;
+                    r_ixr_rsp_to_xram_rsp_rok[index] = false;
+                    r_xram_rsp_fsm                   = XRAM_RSP_DIR_LOCK;
 
 #if DEBUG_MEMC_XRAM_RSP
 if( m_debug_xram_rsp_fsm )
-{	
+{
     std::cout << "  <MEMC " << name() << ".XRAM_RSP_IDLE> Available cache line in TRT:"
               << " index = " << std::dec << index << std::endl;
@@ -2790,16 +3014,26 @@
                 }
             }
-            break;  
+            break;
         }
         ///////////////////////
-        case XRAM_RSP_DIR_LOCK: 	// Takes the lock on the directory
-        {
-            if( r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP ) 
-            {
+        case XRAM_RSP_DIR_LOCK:
+        // Takes the lock on the directory
+        // Takes the lock on TRT
+        // Copy the TRT entry in a local buffer
+        {
+            if (( r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP ) &&
+                ( r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP ))
+            {
+                // copy the TRT entry in the r_xram_rsp_trt_buf local buffer
+                size_t  index = r_xram_rsp_trt_index.read();
+
+                TransactionTabEntry trt_entry(m_transaction_tab.read(index));
+                r_xram_rsp_trt_buf.copy(trt_entry);  // TRT entry local buffer
+
                 r_xram_rsp_fsm = XRAM_RSP_TRT_COPY;
 
 #if DEBUG_MEMC_XRAM_RSP
 if( m_debug_xram_rsp_fsm )
-{	
+{
     std::cout << "  <MEMC " << name() << ".XRAM_RSP_DIR_LOCK> Get access to directory" << std::endl;
 }
@@ -2809,18 +3043,13 @@
         }
         ///////////////////////
-        case XRAM_RSP_TRT_COPY:		// Takes the lock on TRT
-                                    // Copy the TRT entry in a local buffer 
-                                    // and select a victim cache line
-        {
-            if ( (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) ) 
-            {
-                // copy the TRT entry in the r_xram_rsp_trt_buf local buffer
-                size_t 	index = r_xram_rsp_trt_index.read();
-                TransactionTabEntry    trt_entry(m_transaction_tab.read(index));  
-                r_xram_rsp_trt_buf.copy(trt_entry);  // TRT entry local buffer
-
+        case XRAM_RSP_TRT_COPY:
+        // Select a victim cache line
+        {
+            if ( (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) )
+            {
                 // selects & extracts a victim line from cache
                 size_t way = 0;
-                size_t set = m_y[(vci_addr_t)(trt_entry.nline * m_words * 4)];
+                size_t set = m_y[(vci_addr_t)(r_xram_rsp_trt_buf.nline * m_words * 4)];
+
                 DirectoryEntry victim(m_cache_directory.select(set, way));
 
@@ -2828,6 +3057,7 @@
 
                 // copy the victim line in a local buffer
-                for (size_t i=0 ; i<m_words ; i++) 
-                    r_xram_rsp_victim_data[i] = m_cache_data[way][set][i];
+                for (size_t i=0 ; i<m_words ; i++)
+                  r_xram_rsp_victim_data[i] = m_cache_data[way][set][i];
+
                 r_xram_rsp_victim_copy      = victim.owner.srcid;
 #if L1_MULTI_CACHE
@@ -2844,6 +3074,12 @@
                 r_xram_rsp_victim_dirty     = victim.dirty;
 
-                if(!trt_entry.rerror) 	r_xram_rsp_fsm = XRAM_RSP_INVAL_LOCK;
-                else 			        r_xram_rsp_fsm = XRAM_RSP_ERROR_ERASE;      
+                if(!r_xram_rsp_trt_buf.rerror)
+                {
+                  r_xram_rsp_fsm = XRAM_RSP_INVAL_LOCK;
+                }
+                else
+                {
+                  r_xram_rsp_fsm = XRAM_RSP_ERROR_ERASE;
+                }
 
 #if DEBUG_MEMC_XRAM_RSP
@@ -2851,16 +3087,24 @@
 {
     std::cout << "  <MEMC " << name() << ".XRAM_RSP_TRT_COPY> Select a slot: "
-              << " way = " << std::dec << way 
-              << " / set = " << set 
+              << " way = " << std::dec << way
+              << " / set = " << set
               << " / inval_required = " << inval << std::endl;
 }
 #endif
             }
+            else
+            {
+                std::cout << "VCI_MEM_CACHE ERROR "     << name()
+                          << " XRAM_RSP_TRT_COPY state" << std::endl
+                          << "bad TRT allocation"       << std::endl;
+
+                exit(0);
+            }
             break;
         }
         /////////////////////////
-        case XRAM_RSP_INVAL_LOCK:	// check a possible pending inval
-        {
-            if ( r_alloc_upt_fsm == ALLOC_UPT_XRAM_RSP ) 
+        case XRAM_RSP_INVAL_LOCK: // check a possible pending inval
+        {
+            if ( r_alloc_upt_fsm == ALLOC_UPT_XRAM_RSP )
             {
                 size_t index;
@@ -2879,7 +3123,7 @@
 
                 }
-	            else if (m_update_tab.is_full() && r_xram_rsp_victim_inval.read())
+              else if (m_update_tab.is_full() && r_xram_rsp_victim_inval.read())
                 {
-	                r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
+                  r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
 
 #if DEBUG_MEMC_XRAM_RSP
@@ -2891,6 +3135,6 @@
 }
 #endif
-	            }
-                else 
+              }
+                else
                 {
                     r_xram_rsp_fsm = XRAM_RSP_DIR_UPDT;
@@ -2907,5 +3151,5 @@
         }
         /////////////////////////
-        case XRAM_RSP_INVAL_WAIT:	// returns to DIR_LOCK to retry
+        case XRAM_RSP_INVAL_WAIT: // returns to DIR_LOCK to retry
         {
             r_xram_rsp_fsm = XRAM_RSP_DIR_LOCK;
@@ -2913,35 +3157,35 @@
         }
         ///////////////////////
-        case XRAM_RSP_DIR_UPDT:		// updates the cache (both data & directory)
-                                        // and possibly set an inval request in UPT 
+        case XRAM_RSP_DIR_UPDT:   // updates the cache (both data & directory)
+                                        // and possibly set an inval request in UPT
         {
             // signals generation
-            bool inst_read = (r_xram_rsp_trt_buf.trdid & 0x2) && r_xram_rsp_trt_buf.proc_read; 
+            bool inst_read = (r_xram_rsp_trt_buf.trdid & 0x2) && r_xram_rsp_trt_buf.proc_read;
             bool cached_read = (r_xram_rsp_trt_buf.trdid & 0x1) && r_xram_rsp_trt_buf.proc_read;
             // update data
             size_t set   = r_xram_rsp_victim_set.read();
             size_t way   = r_xram_rsp_victim_way.read();
-            for(size_t i=0; i<m_words ; i++) 
+            for(size_t i=0; i<m_words ; i++)
             {
                 m_cache_data[way][set][i] = r_xram_rsp_trt_buf.wdata[i];
 
-                if ( m_monitor_ok ) 
+                if ( m_monitor_ok )
                 {
-                    vci_addr_t address = r_xram_rsp_trt_buf.nline<<6 | i<<2; 
+                    vci_addr_t address = r_xram_rsp_trt_buf.nline<<6 | i<<2;
                     check_monitor("XRAM_RSP_DIR_UPDT", address, r_xram_rsp_trt_buf.wdata[i]);
                 }
             }
-            // compute dirty 
+            // compute dirty
             bool dirty = false;
             for(size_t i=0; i<m_words;i++) dirty = dirty || (r_xram_rsp_trt_buf.wdata_be[i] != 0);
             // update directory
             DirectoryEntry entry;
-            entry.valid	  = true;
+            entry.valid   = true;
             entry.is_cnt  = false;
-            entry.lock	  = false;
-            entry.dirty	  = dirty;
-            entry.tag	  = r_xram_rsp_trt_buf.nline / m_sets;
+            entry.lock    = false;
+            entry.dirty   = dirty;
+            entry.tag   = r_xram_rsp_trt_buf.nline / m_sets;
             entry.ptr     = 0;
-            if(cached_read) 
+            if(cached_read)
             {
                 entry.owner.srcid   = r_xram_rsp_trt_buf.srcid;
@@ -2951,6 +3195,6 @@
                 entry.owner.inst    = inst_read;
                 entry.count         = 1;
-            } 
-            else 
+            }
+            else
             {
                 entry.owner.srcid    = 0;
@@ -2965,20 +3209,20 @@
             if (r_xram_rsp_victim_inval.read())
             {
-                bool   brdcast 		= r_xram_rsp_victim_is_cnt.read();
-                size_t index 		= 0;
-                size_t count_copies 	= r_xram_rsp_victim_count.read();
-
-                bool   wok = m_update_tab.set(	false,		// it's an inval transaction
-                				brdcast,	// set brdcast bit
-                				false,  	// it does not need a response
-                				0,		// srcid
-                				0,		// trdid
-                				0,		// pktid
-                				r_xram_rsp_victim_nline.read(),
-                				count_copies,
-                				index);
+                bool   brdcast    = r_xram_rsp_victim_is_cnt.read();
+                size_t index    = 0;
+                size_t count_copies   = r_xram_rsp_victim_count.read();
+
+                bool   wok = m_update_tab.set(  false,    // it's an inval transaction
+                        brdcast,  // set brdcast bit
+                        false,    // it does not need a response
+                        0,    // srcid
+                        0,    // trdid
+                        0,    // pktid
+                        r_xram_rsp_victim_nline.read(),
+                        count_copies,
+                        index);
                 r_xram_rsp_upt_index = index;
 
-                if (!wok) 
+                if (!wok)
                 {
                     std::cout << "VCI_MEM_CACHE ERROR " << name() << " XRAM_RSP_HEAP_LAST state" << std::endl;
@@ -2992,6 +3236,6 @@
 {
     std::cout << "  <MEMC " << name() << ".XRAM_RSP_DIR_UPDT> Directory update: "
-              << " way = " << std::dec << way 
-              << " / set = " << set 
+              << " way = " << std::dec << way
+              << " / set = " << set
               << " / count = " << entry.count
               << " / is_cnt = " << entry.is_cnt << std::endl;
@@ -3004,5 +3248,5 @@
 
             // If the victim is not dirty, we don't need another XRAM  put transaction,
-            // and we canwe erase the TRT entry 
+            // and we canwe erase the TRT entry
             if (!r_xram_rsp_victim_dirty.read())  m_transaction_tab.erase(r_xram_rsp_trt_index.read());
 
@@ -3017,8 +3261,8 @@
         case XRAM_RSP_TRT_DIRTY:  // set the TRT entry (write to XRAM) if the victim is dirty
         {
-            if ( r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP ) 
+            if ( r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP )
             {
                 m_transaction_tab.set( r_xram_rsp_trt_index.read(),
-                                       false,				// write to XRAM
+                                       false,       // write to XRAM
                                        r_xram_rsp_victim_nline.read(),  // line index
                                        0,
@@ -3035,5 +3279,5 @@
 {
     std::cout << "  <MEMC " << name() << ".XRAM_RSP_TRT_DIRTY> Set TRT entry for the put transaction:"
-	      << " dirty victim line = " << r_xram_rsp_victim_nline.read() << std::endl;
+        << " dirty victim line = " << r_xram_rsp_victim_nline.read() << std::endl;
 }
 #endif
@@ -3047,10 +3291,10 @@
         case XRAM_RSP_DIR_RSP:     // Request a response to TGT_RSP FSM
         {
-            if ( !r_xram_rsp_to_tgt_rsp_req.read() ) 
+            if ( !r_xram_rsp_to_tgt_rsp_req.read() )
             {
                 r_xram_rsp_to_tgt_rsp_srcid = r_xram_rsp_trt_buf.srcid;
                 r_xram_rsp_to_tgt_rsp_trdid = r_xram_rsp_trt_buf.trdid;
                 r_xram_rsp_to_tgt_rsp_pktid = r_xram_rsp_trt_buf.pktid;
-                for (size_t i=0; i < m_words; i++) r_xram_rsp_to_tgt_rsp_data[i] = r_xram_rsp_trt_buf.wdata[i]; 
+                for (size_t i=0; i < m_words; i++) r_xram_rsp_to_tgt_rsp_data[i] = r_xram_rsp_trt_buf.wdata[i];
                 r_xram_rsp_to_tgt_rsp_word   = r_xram_rsp_trt_buf.word_index;
                 r_xram_rsp_to_tgt_rsp_length = r_xram_rsp_trt_buf.read_length;
@@ -3059,5 +3303,5 @@
 
                 if      ( r_xram_rsp_victim_inval ) r_xram_rsp_fsm = XRAM_RSP_INVAL;
-                else if ( r_xram_rsp_victim_dirty ) r_xram_rsp_fsm = XRAM_RSP_WRITE_DIRTY; 
+                else if ( r_xram_rsp_victim_dirty ) r_xram_rsp_fsm = XRAM_RSP_WRITE_DIRTY;
                 else                                r_xram_rsp_fsm = XRAM_RSP_IDLE;
 
@@ -3066,5 +3310,5 @@
 if( m_debug_xram_rsp_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".XRAM_RSP_DIR_RSP> Request the TGT_RSP FSM to return data:" 
+    std::cout << "  <MEMC " << name() << ".XRAM_RSP_DIR_RSP> Request the TGT_RSP FSM to return data:"
               << " rsrcid = " << std::dec << r_xram_rsp_trt_buf.srcid
               << " / address = " << std::hex << r_xram_rsp_trt_buf.nline*m_words*4
@@ -3076,14 +3320,14 @@
         }
         ////////////////////
-        case XRAM_RSP_INVAL:	// send invalidate request to INIT_CMD FSM
-        {
-            if(   !r_xram_rsp_to_init_cmd_multi_req.read() && 
-                  !r_xram_rsp_to_init_cmd_brdcast_req.read() ) 
-            {	      
+        case XRAM_RSP_INVAL:  // send invalidate request to INIT_CMD FSM
+        {
+            if(   !r_xram_rsp_to_init_cmd_multi_req.read() &&
+                  !r_xram_rsp_to_init_cmd_brdcast_req.read() )
+            {
                 bool multi_req = !r_xram_rsp_victim_is_cnt.read();
                 bool last_multi_req  = multi_req && (r_xram_rsp_victim_count.read() == 1);
                 bool not_last_multi_req = multi_req && (r_xram_rsp_victim_count.read() != 1);
 
-                r_xram_rsp_to_init_cmd_multi_req    = last_multi_req; 
+                r_xram_rsp_to_init_cmd_multi_req    = last_multi_req;
                 r_xram_rsp_to_init_cmd_brdcast_req  = r_xram_rsp_victim_is_cnt.read();
                 r_xram_rsp_to_init_cmd_nline        = r_xram_rsp_victim_nline.read();
@@ -3098,5 +3342,5 @@
 
                 if ( r_xram_rsp_victim_dirty )  r_xram_rsp_fsm = XRAM_RSP_WRITE_DIRTY;
-                else if (not_last_multi_req)    r_xram_rsp_fsm = XRAM_RSP_HEAP_ERASE;
+                else if (not_last_multi_req)    r_xram_rsp_fsm = XRAM_RSP_HEAP_REQ;
                 else                            r_xram_rsp_fsm = XRAM_RSP_IDLE;
 
@@ -3104,5 +3348,5 @@
 if( m_debug_xram_rsp_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".XRAM_RSP_INVAL> Send an inval request to INIT_CMD FSM:" 
+    std::cout << "  <MEMC " << name() << ".XRAM_RSP_INVAL> Send an inval request to INIT_CMD FSM:"
               << " victim line = " << r_xram_rsp_victim_nline.read() << std::endl;
 }
@@ -3112,7 +3356,7 @@
         }
         //////////////////////////
-        case XRAM_RSP_WRITE_DIRTY:	// send a write request to IXR_CMD FSM
-        {
-            if ( !r_xram_rsp_to_ixr_cmd_req.read() ) 
+        case XRAM_RSP_WRITE_DIRTY:  // send a write request to IXR_CMD FSM
+        {
+            if ( !r_xram_rsp_to_ixr_cmd_req.read() )
             {
                 r_xram_rsp_to_ixr_cmd_req = true;
@@ -3124,5 +3368,5 @@
                 bool multi_req = !r_xram_rsp_victim_is_cnt.read() && r_xram_rsp_victim_inval.read();
                 bool not_last_multi_req = multi_req && (r_xram_rsp_victim_count.read() != 1);
-                if ( not_last_multi_req )   r_xram_rsp_fsm = XRAM_RSP_HEAP_ERASE;
+                if ( not_last_multi_req )   r_xram_rsp_fsm = XRAM_RSP_HEAP_REQ;
                 else                        r_xram_rsp_fsm = XRAM_RSP_IDLE;
 
@@ -3130,5 +3374,5 @@
 if( m_debug_xram_rsp_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".XRAM_RSP_WRITE_DIRTY> Send the put request to IXR_CMD FSM:" 
+    std::cout << "  <MEMC " << name() << ".XRAM_RSP_WRITE_DIRTY> Send the put request to IXR_CMD FSM:"
               << " victim line = " << r_xram_rsp_victim_nline.read() << std::endl;
 }
@@ -3137,8 +3381,29 @@
             break;
         }
+
         /////////////////////////
-        case XRAM_RSP_HEAP_ERASE:	// erase the list of copies and sent invalidations
-        {
-            if( r_alloc_heap_fsm.read() == ALLOC_HEAP_XRAM_RSP ) 
+        case XRAM_RSP_HEAP_REQ:
+        // Get the lock to the HEAP directory
+        {
+          if( r_alloc_heap_fsm.read() == ALLOC_HEAP_XRAM_RSP )
+          {
+            r_xram_rsp_fsm = XRAM_RSP_HEAP_ERASE;
+          }
+
+#if DEBUG_MEMC_XRAM_RSP
+          if( m_debug_xram_rsp_fsm )
+          {
+            std::cout 
+              << "  <MEMC " << name() << ".XRAM_RSP_HEAP_REQ> Requesting HEAP lock "
+              << std::endl;
+          }
+#endif
+          break;
+        }
+
+        /////////////////////////
+        case XRAM_RSP_HEAP_ERASE: // erase the list of copies and sent invalidations
+        {
+            if( r_alloc_heap_fsm.read() == ALLOC_HEAP_XRAM_RSP )
             {
                 HeapEntry entry = m_heap.read(r_xram_rsp_next_ptr.read());
@@ -3157,11 +3422,11 @@
                         r_xram_rsp_to_init_cmd_multi_req = true;
                         r_xram_rsp_fsm = XRAM_RSP_HEAP_LAST;
-                    } 
-                    else 
+                    }
+                    else
                     {
                         r_xram_rsp_fsm = XRAM_RSP_HEAP_ERASE;
                     }
-                } 
-                else 
+                }
+                else
                 {
                     r_xram_rsp_fsm = XRAM_RSP_HEAP_ERASE;
@@ -3171,5 +3436,5 @@
 if( m_debug_xram_rsp_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".XRAM_RSP_HEAP_ERASE> Erase the list of copies:" 
+    std::cout << "  <MEMC " << name() << ".XRAM_RSP_HEAP_ERASE> Erase the list of copies:"
               << " srcid = " << std::dec << entry.owner.srcid
               << " / inst = " << std::dec << entry.owner.inst << std::endl;
@@ -3180,5 +3445,5 @@
         }
         /////////////////////////
-        case XRAM_RSP_HEAP_LAST:	// last member of the list
+        case XRAM_RSP_HEAP_LAST:  // last member of the list
         {
             if ( r_alloc_heap_fsm.read() != ALLOC_HEAP_XRAM_RSP )
@@ -3200,6 +3465,6 @@
                 last_entry.next     = r_xram_rsp_next_ptr.read();
                 m_heap.unset_full();
-            } 
-            else 
+            }
+            else
             {
                 last_entry.next     = free_pointer;
@@ -3220,5 +3485,5 @@
         }
         // ///////////////////////
-        case XRAM_RSP_ERROR_ERASE:	// erase TRT entry in case of error
+        case XRAM_RSP_ERROR_ERASE:  // erase TRT entry in case of error
         {
             m_transaction_tab.erase(r_xram_rsp_trt_index.read());
@@ -3237,7 +3502,7 @@
         }
         ////////////////////////
-        case XRAM_RSP_ERROR_RSP:     // Request an error response to TGT_RSP FSM 
-        {
-            if ( !r_xram_rsp_to_tgt_rsp_req.read() ) 
+        case XRAM_RSP_ERROR_RSP:     // Request an error response to TGT_RSP FSM
+        {
+            if ( !r_xram_rsp_to_tgt_rsp_req.read() )
             {
                 r_xram_rsp_to_tgt_rsp_srcid  = r_xram_rsp_trt_buf.srcid;
@@ -3265,5 +3530,5 @@
 
     ////////////////////////////////////////////////////////////////////////////////////
-    //		CLEANUP FSM
+    //    CLEANUP FSM
     ////////////////////////////////////////////////////////////////////////////////////
     // The CLEANUP FSM handles the cleanup request from L1 caches.
